//=====================================================================================================================
// This code is from Leuze electronic GmbH + Co. KG. It is free software, WITHOUT ANY GUARANTEES OR WARRANTY
// (without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE).
// Although the author has attempted to find and correct any bugs in this free software, the author is not responsible
// for any damage or losses of any kind caused by the use or misuse of the program. 
// The author is under no obligation to provide support, service, corrections, or upgrades to this software.
//--------------------------------------------------------------------------------------------------------------------
/**
@file         native.h
@brief        Native Handling for LxS-Lib
@author       Archipov Slava
@version      1.0.0
*/
//=====================================================================================================================

#ifndef   __DEVEL_NATIVE_H__
#define   __DEVEL_NATIVE_H__

//---------------------------------------------------------------------------------------------------------------------
// common interface
//
#include "LxS_Lib.h"

//---------------------------------------------------------------------------------------------------------------------
#ifdef    __cplusplus
extern "C"
{
#endif // __cplusplus

  //! Native-Interface for LxS-Lib
  namespace Native
  {
    DLLSPEC   LxS::Device *   CALLBACK  CreateInstance(void);
    DLLSPEC   bool            CALLBACK  ReleaseInstance(LxS::Device * lxs);
    DLLSPEC   bool            CALLBACK  ConnectDevice(LxS::Device * lxs, const char * addr, int port);
    DLLSPEC   bool            CALLBACK  DisconnectDevice(LxS::Device * lxs);
    DLLSPEC   bool            CALLBACK  SetDeviceLaserGate(LxS::Device * lxs, bool state);
    DLLSPEC   bool            CALLBACK  SetDeviceToCommandMode(LxS::Device * lxs, bool mode);
    DLLSPEC   UINT16          CALLBACK  GetDeviceScanNumber(LxS::Device * lxs);
    DLLSPEC   UINT32          CALLBACK  GetDeviceEcoderValue(LxS::Device * lxs);
    DLLSPEC   UINT16          CALLBACK  GetDeviceInspectionTask(LxS::Device * lxs);
    DLLSPEC   bool            CALLBACK  SetDeviceInspectionTask(LxS::Device * lxs, UINT16 task);
    DLLSPEC   bool            CALLBACK  DeviceEthernetTrigger(LxS::Device * lxs);
    DLLSPEC   bool            CALLBACK  DeviceDataSet(LxS::Device * lxs, sWrapper * wrap);
  }

#ifdef    __cplusplus
}
#endif // __cplusplus

#endif // __DEVEL_NATIVE_H__
